#include<R.h>

void mysum(double *x, int *n, double *res) {
  for (int i=0; i<*n; i++)
    *res += x[i];
}

void mymean(double *x, int *n, double *res) {
  int i;
  *res = 0.0;
  for (i=0; i<*n; i++) 
    *res += x[i];
  *res /= (float)*n;
}

void myouter(double *x, double *y, int *nx, int *ny, double *res) {
  int i, j, id;
  for (j=0; j<*ny; j++) {
    id = *nx*j;
    for (i=0; i<*nx; i++) 
      res[id+i] = x[i]*y[j];
  }
}

void myprod(double *x, double *y, int *dims, double *res) {
  int i, j, k, id1=0, id2=0, id3=0;
  for (j=0; j<dims[2]; j++) {
    for (i=0; i<dims[0]; i++) {
      id3 = 0;
      for (k=0; k<dims[1]; k++) {
        res[id1] += x[id3+i] * y[id2+k];
        id3 += dims[0];
      }
      id1++;
    }
    id2 += dims[1];
  }
}

